/*
 * Greentext and Redtext Emulator
 * Version 1.0
 * Emulates imageboard greentext and redtext in TF2 text chat
 * 
 * This program is free software. It comes without any warranty, to the extent
 * permitted by applicable law. You can redistribute it and/or modify it under
 * the terms of the Do What The Fuck You Want To Public License, Version 2, as
 * published by Sam Hocevar. See http://www.wtfpl.net/ for more details.
 * 
 */

#include <sourcemod>
#include <chat-processor>

#pragma semicolon 1

#define GREENTEXT_COLOR "#789922"
#define REDTEXT_COLOR   "#e0727f"

ConVar g_greentextEnabled;
ConVar g_redtextEnabled;

public Plugin myinfo =
{
	name = "Greentext and Redtext Emulator",
	author = "lolwut",
	description = "Emulates imageboard greentext and redtext in TF2 text chat",
	version = "1.0",
	url = "https://www.lolwut.info"
};

public void OnPluginStart()
{
	PrintToServer(">using greentext in TF2"); // SHIGGY DIGGY
	g_greentextEnabled = CreateConVar("sm_greentext_enable", "1", "Enables greentext in chat");
	g_redtextEnabled = CreateConVar("sm_redtext_enable", "1", "Enables redtext in chat");
	AutoExecConfig(true, "greentext");
}

public Action CP_OnChatMessage(int& author, ArrayList recipients, char[] flagstring, char[] name, char[] message, bool& processcolors, bool& removecolors)
{
	if (message[0] == '>' && g_greentextEnabled.BoolValue)
	{
		Format(message, MAXLENGTH_MESSAGE, "{%s}%s", GREENTEXT_COLOR, message);
		return Plugin_Changed;
	}
	else if (message[0] == '<' && g_redtextEnabled.BoolValue)
	{
		Format(message, MAXLENGTH_MESSAGE, "{%s}%s", REDTEXT_COLOR, message);
		return Plugin_Changed;
	}
	return Plugin_Handled;
}
